#!/usr/bin/env python
#coding:utf-8

import sys
import os
import platform
import threading
import pyaudio
import wave

from PyQt4.QtGui import *
from PyQt4.QtCore import *



#################################################################################

# Thread gerant le son en mm temps que l'affichage des notes et du nom des notes

class Son(threading.Thread):
    def __init__(self, indN, nom='', parent=None):
        threading.Thread.__init__(self)
        self.indN = indN
        self.stop = True
 
        
    def run(self):
        self.stop = False
        sndFile ="sons/"+str(self.indN)+".wav"
        f= wave.open(sndFile, 'rb' )
        p = pyaudio.PyAudio()

        chunk = 1024
 

        # open stream
        stream = p.open(format =
        p.get_format_from_width(f.getsampwidth()),
        channels = f.getnchannels(),
        rate = f.getframerate(),
        output = True)

        

        # read data
        data = f.readframes(chunk)

        #play stream
        while(data!=''):
            stream.write(data)
            data = f.readframes(chunk)

        stream.close()
        p.terminate()
        
    def stopSon(self):
        self.stop = True
    



###################################################################################

#La portee

class Portee(QDialog):
    clicked = pyqtSignal()
    click = pyqtSignal()
    def __init__(self, parent=None):
        super(Portee, self).__init__(parent)
        self.setWindowTitle("Staff")
        portee  = QLabel(self)
        pixmap_img = QPixmap("images/portee3.jpg")
        portee.setPixmap(pixmap_img)
        portee.adjustSize()
        portee.setGeometry(0,0,489,500)
        portee.setFixedSize(489,500)
        self.setWindowIcon(QIcon("images/cle-de-sol.png"))
        imCurseur = QPixmap("images/curs4.png")
        monCurseur = QCursor(imCurseur)

        self.signalMapper_portee = QSignalMapper(self);
        self.signalMapper_portee.mapped.connect(self.afficheSaxoNote2);

        i=0
        self.boutonZone = ['','','', '','','','','','','','','','','','','','','','','','','','','','','','']
        while(i<27):
            self.boutonZone[i] = QPushButton(self)

            self.boutonZone[i].setGeometry(190,15*i+10,156,15)
            self.boutonZone[i].setFlat(True)
            self.boutonZone[i].setFocusPolicy(Qt.NoFocus)
            self.boutonZone[i].setStyleSheet("QPushButton:flat:pressed  border: none; };")
            self.boutonZone[i].setCursor(monCurseur)
            self.signalMapper_portee.setMapping(self.boutonZone[i], i)
            self.boutonZone[i].clicked.connect(self.signalMapper_portee.map)
            i=i+1

        self.boutonZone[0].setDisabled(True)

    def click(x):
        self.emit(SIGNAL("clicked()"))
        return x

    def afficheSaxoNote2(self, index):
        self.emit(SIGNAL("clicked(index)"))
        i=0
        while(i<27):
            self.boutonZone[i].setIcon(QIcon(""))
            self.boutonZone[i].setIconSize(QSize(0,0))
            i=i+1
                
        self.boutonZone[index].setIcon(QIcon("images/note11.png"))
        self.boutonZone[index].setIconSize(QSize(30,30))


    def moveNote(self, k):
        iz=0
        while (iz<27):
            """si on clique # et que la note n est pas alteree"""
            """On diese la note si ce n est pas Si ou Mi"""

            if ( (k==0) and ( self.boutonZone[iz].iconSize() == QSize(30,30) )  ):
                j=0
                while(j<27):
                    self.boutonZone[j].setIcon(QIcon(""))
                    self.boutonZone[j].setIconSize(QSize(0,0))
                    j=j+1
                    

                if ((iz==2) or (iz==5) or (iz==9) or (iz==12) or (iz==16) or (iz==19) or (iz==23) or (iz==26)):
                    self.boutonZone[iz-1].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz-1].setIconSize(QSize(30,30))
                    break
                    

                elif (iz==1):
                    self.boutonZone[iz].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz].setIconSize(QSize(30,30))

                else:
                    self.boutonZone[iz].setIcon(QIcon("images/noteDiese11.png"))
                    self.boutonZone[iz].setIconSize(QSize(60,30))
                    break


                """Si on clique # et que la note est deja alteree"""
                """On passe a la note suivante"""

            elif( (k==0) and ( self.boutonZone[iz].iconSize() == QSize(60,30) )  ):
                j=0
                while(j<27):
                    self.boutonZone[j].setIcon(QIcon(""))
                    self.boutonZone[j].setIconSize(QSize(0,0))
                    j=j+1

                if (iz==26):
                    
                    self.boutonZone[iz].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz].setIconSize(QSize(30,30))

                    break
                    

                elif (iz == 0):
                    
                    self.boutonZone[iz].setIcon(QIcon("images/noteDiese11.png"))
                    self.boutonZone[iz].setIconSize(QSize(60,30))

                    break
                    

                else:
                    
                    self.boutonZone[iz-1].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz-1].setIconSize(QSize(30,30))
                    break                

            #"""Si on clique b et que la note n est pas alteree"""
            #"""On diese la note inferieure si ce nest pas Si ou Mi"""

            elif( (k==1) and (self.boutonZone[iz].iconSize() == QSize(30,30)) ):
                j=0
                while(j<27):
                    self.boutonZone[j].setIcon(QIcon(""))
                    self.boutonZone[j].setIconSize(QSize(0,0))
                    j=j+1

                if ((iz==1) or (iz==4) or (iz==8) or (iz==11) or (iz==15) or (iz==18 or (iz==22) or (iz==25))):
                

                    self.boutonZone[iz+1].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz+1].setIconSize(QSize(30,30))
                    iz = 0
                    break

                

                elif (iz == 26):
                
                    self.boutonZone[iz].setIcon(QIcon("images/noteBemol11.png"))
                    self.boutonZone[iz].setIconSize(QSize(60,30))
                    iz = 0
                    break
                

                else:
                
                    self.boutonZone[iz+1].setIcon(QIcon("images/noteDiese11.png"))
                    self.boutonZone[iz+1].setIconSize(QSize(60,30))
                    iz = 0
                    break
                


            

 #       """Si on clique b et que la note est alteree"""
  #      """On affiche la mm note sans la diese"""
   #     """Sauf le Si grave qui devient Si b grave"""

            elif ( (k==1) and (self.boutonZone[iz].iconSize() == QSize(60,30)) ):
                j=0
                while(j<27):
                    self.boutonZone[j].setIcon(QIcon(""))
                    self.boutonZone[j].setIconSize(QSize(0,0))
                    j=j+1

                if (iz != 26):
                
                    self.boutonZone[iz].setIcon(QIcon("images/note11.png"))
                    self.boutonZone[iz].setIconSize(QSize(30,30))
                    iz = 0
                    break
                

                elif (iz == 26):
                
                    self.boutonZone[iz].setIcon(QIcon("images/noteBemol11.png"))
                    self.boutonZone[iz].setIconSize(QSize(60,30))
                    iz = 0
                    break
                

            iz=iz+1

    def initPortee(self):
        y=0
        while(y<27):
            self.boutonZone[y].setIcon(QIcon(""))
            self.boutonZone[y].setIconSize(QSize(0,0))
            y=y+1
         

    


##################################################################################



#Le Piano
            
class Piano(QDialog):
    def __init__(self, parent=None):
        super(Piano, self).__init__(parent)
        piano  = QLabel(self)
        pixmap_img2 = QPixmap("images/piano.png")
        piano.setPixmap(pixmap_img2)
        piano.setGeometry(0,0,400,100)
        piano.setFixedSize(400,100)
        self.setWindowTitle("Keyboard")

        imCurseurPiano = QPixmap("images/hand1.png")
        curseurPiano = QCursor(imCurseurPiano)

        self.boutonB = ['','','','','','','','','','','','','','','','','','','','','','','','','','','',''
        ,'','','','','','','','','','','','','','','','','','','']

        self.boutonN = ['','','','','','','','','','','','','','','','','','','']

        self.signalMapper_piano = QSignalMapper(self);
        #connect(signalMapper_portee, SIGNAL(mapped(int)), this, SLOT(afficheSaxoNote2(int)));
        #connect(self.signalMapper_piano,SIGNAL(mapped(int)),self,SLOT(emmettre(int)));

        
        i=20
        while (i<10+15):
            self.boutonB[i] =  QPushButton(self)
            self.boutonB[i].setGeometry(14*(i-20)+26,71,6,20)
            self.boutonB[i].setFlat(True)
            self.boutonB[i].setFocusPolicy(Qt.NoFocus)
            i=i+1

            
        i=25
        while(i<20+15):
            
            self.boutonB[i] = QPushButton(self);

            self.boutonB[i].setGeometry(14*(i-20)+27,71,6,20)
            self.boutonB[i].setFlat(True)
            self.boutonB[i].setFocusPolicy(Qt.NoFocus)
            i=i+1
            
        i=20+15
        while (i<15+32):
            
            self.boutonB[i] = QPushButton(self);

            self.boutonB[i].setGeometry(14*(i-20)+29,71,6,20)
            self.boutonB[i].setFlat(True)
            self.boutonB[i].setFocusPolicy(Qt.NoFocus)
            i=i+1
            
        i=0
        while (i<19):
            
            if(i==0 or i==1):
                
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+20,34,5,20)
                self.boutonN[i].setFlat(True)
                

            elif(i==2 or i==3 ):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+26,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif(i==4 or i==5 or i==6):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+30,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif (i==7 or i==8 ):
    
                self.boutonN[i] =  QPushButton(self);
                self.boutonN[i].setGeometry(18*i+35,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif(i==9 or i==10 or i==11):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+40,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif (i==12 or i==13 ):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+45,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif(i==14 or i==15 or i==16):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+50,34,5,20)
                self.boutonN[i].setFlat(True)
    

            elif (i==17 or i==18):
    
                self.boutonN[i] =  QPushButton(self)
                self.boutonN[i].setGeometry(18*i+54,34,5,20)
                self.boutonN[i].setFlat(True)

            i=i+1

        i=0
        while(i<19):
            self.boutonN[i].setCursor(curseurPiano)
            self.boutonN[i].setFlat(True)
            self.boutonN[i].setStyleSheet("QPushButton:flat:pressed { border: none; };")
            self.boutonN[i].setFocusPolicy(Qt.NoFocus)
            self.signalMapper_piano.setMapping(self.boutonN[i], i)
            #connect(self.boutonN[i], SIGNAL(clicked()), signalMapper_piano, SLOT(map()))
            self.boutonN[i].clicked.connect(self.signalMapper_piano.map)
            i=i+1

        #self.signalMapper_piano.mapped.connect(MainWindow.noteFromPiano)

        i=20
        while( i<47 ):
            self.boutonB[i].setCursor(curseurPiano)
            self.boutonB[i].setFlat(True)
            self.boutonB[i].setStyleSheet("QPushButton:flat:pressed { border: none; };")
            self.signalMapper_piano.setMapping(self.boutonB[i], i)
            self.boutonB[i].clicked.connect(self.signalMapper_piano.map)
            #connect(self.boutonB[i], SIGNAL(clicked()), self.signalMapper_piano, SLOT(map()))
            i=i+1

        #self.signalMapper_piano.connect(MainWindow.noteFromPiano)
    
    
    def initIconPiano(self):
        
        i=20
        while(i<46):
            self.boutonB[i].setIcon(QIcon(""))
            self.boutonB[i].setIconSize(QSize(0,0))
            self.boutonB[i].setFlat(True)
            i=i+1
    
        i=0
        while (i<19):
            self.boutonN[i].setIcon(QIcon(""))
            self.boutonN[i].setIconSize(QSize(0,0))
            self.boutonN[i].setFlat(True)
            i=i+1
    
#################################################################################

    



# Les partitions

class Partition(QDialog):
    def __init__(self, parent=None):
        super(Partition, self).__init__(parent)
        self.resize(400,600)
        #self.setCentralWidget(self.vue)
        self.setWindowTitle("Score")
        


###############################################################################
#Fenetre de doigtes alternatifs

class Alt(QDialog):
    def __init__(self,img_alt = QPixmap):
        super(Alt, self).__init__()
        self.setFixedSize(310,490)
        self.lab_alt = QLabel(self)
        self.lab_alt.setPixmap(img_alt)
        #self.lab_alt.show()
        self.setWindowIcon(QIcon("images/splash12.png"))
        
        self.setFixedSize(310,490)
        #self.setVisible(False)
        
        #self.setVisible(True)

    def altclose(self):
        self.close()
        
    def altshow(self):
        self.show()
        

###############################################################################

#DERIVATION DE CLASSE QLABEL

class MouseLab(QLabel):

    mouseEntered = pyqtSignal()
    mouseLeft = pyqtSignal()
    
    def __init__(self, parent=None):
        super(MouseLab, self).__init__(parent)
        #QLabel.__init__(self, parent)
        
        self.setMouseTracking(True)
        self.connect(self,SIGNAL("mouseLeft()"),self,SLOT("clear()"))
        #self.connect(self, SIGNAL("mouseEntered()"), self, SLOT("chImage()"))

    def mouseMoveEvent(self, QMouseEvent):
        if(self.underMouse()): self.setPixmap(QPixmap("images/survol.png"))
   #     print ("Mouse Pointer is currently hovering at: ", event.pos())

    def enterEvent(self, QMouseEvent):
        self.emit(SIGNAL("mouseEntered()"))

    def leaveEvent(self, QMouseEvent):
        self.emit(SIGNAL("mouseLeft()"))

        




###############################################################################
# L AIDE
class Help(QDialog):
    def __init__(self, parent=None):
        super(Help, self).__init__(parent)
        self.help_lab =  QLabel(self)
        self.help_lab.setGeometry(15,15,610,50)
        self.help_lab.setStyleSheet("QLabel{background-color : whiteborder-width : 3px border-color : blackborder-style:solid}")
        self.titre = QFont("Palatino",16,1)
        self.titre.setBold(True)
        self.titre.setItalic(True)
        self.help_lab.setFont(self.titre)
        #help_lab.setAlignment(QAlignCenter)
        self.help_lab.setText("G!ant Steps Help Center")

        tabW =  QTabWidget(self)
        tabW.setGeometry(15,75,610,590)
        tabW.scroll(0,1500)
   

        self.general =  QLabel(self)

        tabW.addTab(self.general, "Saxophone Schema")



        self.tabPix =  [  QPixmap("images/key1.png") ,  QPixmap("images/key2.png"), QPixmap("images/key3.png")
        , QPixmap("images/key4.png"), QPixmap("images/key5.png") ,  QPixmap("images/key6.png")
        ,  QPixmap("images/key7.png"),  QPixmap("images/key8.png"),  QPixmap("images/keycote1.png")
        ,  QPixmap("images/keycote2.png"),  QPixmap("images/keycote3.png"),  QPixmap("images/keycote4.png")
        ,  QPixmap("images/keycote5.png"),  QPixmap("images/red.png"),  QPixmap("images/dod.png")
        ,  QPixmap("images/manet1.png"),  QPixmap("images/manet2.png"),  QPixmap("images/manet3.png")
        ,  QPixmap("images/sold1.png"),  QPixmap("images/sold2.png"),  QPixmap("images/sold3.png")
        ,  QPixmap("images/sold4.png")
        ,  QPixmap("images/oct.png")]


        self.lab_sch =  QLabel(self.general)

        self.lab_sch.setGeometry(0,0,305,490)


        self.lab_sax =  QLabel(self.general)
        self.lab_sax.setGeometry(305,0,305,490)


        schema =  QPixmap("images/DodMedium.png")

        self.saxo =  QPixmap("images/help_sax.png")

        self.lab_sch.setPixmap(schema)
        self.lab_sax.setPixmap(self.saxo)

        lab_texto =  QLabel(self.general)
        lab_texto.setGeometry(0,480,610,50)
        texto = "   <h2>Hover over the saxophone keys on the schema.</h2>"
        lab_texto.setText(texto)

        i=0
        self.mLab = ['','','','','','','','','','','','','','','','','','','','','','','']
        while (i<23):
            self.mLab[i] = MouseLab(self.lab_sch)
            self.mLab[i].setIndent(i)
            self.mLab[i].mouseEntered.connect(self.chImage)
            self.mLab[i].mouseLeft.connect(self.initIm)
            i=i+1
        

 #       self.mLab[0].mouseEntered.connect(self.chImage)

        mask =  QBitmap(QPixmap("images/masque.png"))
        mask_lad =  QBitmap(QPixmap("images/masque.png").scaled(21,19))
 

        #cles de fourche a sol
        self.mLab[0].setGeometry(147,17,37,42)
        self.mLab[1].setGeometry(148,60,37,42)
        self.mLab[2].setGeometry(155,104,22,20)
        self.mLab[3].setGeometry(148,127,37,42)
        self.mLab[4].setGeometry(147,171,37,42)

        #cles de fa a re
        self.mLab[5].setGeometry(146,344,37,42)
        self.mLab[6].setGeometry(146,390,37,42)
        self.mLab[7].setGeometry(146,438,37,42)

        i=0
        while(i<8):
            self.mLab[i].setMask(mask)
            i=i+1
        

        self.mLab[2].setMask(mask_lad)
        self.mLab[22].setMask(mask_lad)
    
        #//cles de cote la diese
        self.mLab[8].setGeometry(59,187,13,40)
        self.mLab[9].setGeometry(59,235,13,40)
        self.mLab[10].setGeometry(59,282,13,40)

        #//cles de cote fa diese
        self.mLab[11].setGeometry(86,327,13,40)
        self.mLab[12].setGeometry(86,374,13,40)

        #//cles de do/Si et re diese
        self.mLab[13].setGeometry(29,430,47,14)
        self.mLab[14].setGeometry(29,452,47,14)


        #//manettes du dos
        self.mLab[15].setGeometry(220,17,8,24)
        self.mLab[16].setGeometry(237,31,8,24)
        self.mLab[17].setGeometry(220,50,8,24)


       # //cles a sol diese
        self.mLab[18].setGeometry(226,133,37,16)
        self.mLab[19].setGeometry(226,156,15,11)
        self.mLab[20].setGeometry(249,156,15,11)
        self.mLab[21].setGeometry(227,173,37,16)


        #//cle d octave
        self.mLab[22].setGeometry(97,49,19,15)



        lab_staff =  QLabel(self)
        lab_staff.scroll(1000,0)
        tabW.addTab(lab_staff, "Staff")


        zoneTexte =  QTextEdit(lab_staff)
        zoneTexte.setGeometry(0,0,610,800)
        zoneTexte.scroll(1000,0)
        zoneTexte.setReadOnly(True)
        zoneTexte.setAlignment(Qt.AlignJustify)


        texte = ['','','','','','','','','','','','','','','','','','','','','','','',''
        ,'','','','']
        fichierHelp = QFile("fichier_aide.txt")
        ins = QTextStream(fichierHelp)

        fichierHelp.open(QIODevice.ReadOnly | QIODevice.Text)

        while(not ins.atEnd()):
            texte.append(ins.readLine())

        i=0
        while (i<4):
            zoneTexte.append(texte[i])
            zoneTexte.show()
            i=i+1



       #//      connect(help_lab_liste,SIGNAL(linkActivated(QString)),self,SLOT(vaAlaLigne(QString)))

        fichierHelp.close()


        lab_keyboard =  QLabel(self)
        tabW.addTab(lab_keyboard, "Keyboard")
        zone2 =  QTextEdit(lab_keyboard)
        zone2.setGeometry(0,0,610,800)
        zone2.scroll(1000,0)
        zone2.setReadOnly(True)
        zone2.setAlignment(Qt.AlignJustify)

        i=4
        while(i<11):
            zone2.append(texte[i])
            i=i+1



        lab_transcrip =  QLabel(self)
        lab_transcrip.scroll(0,1500)
        tabW.addTab(lab_transcrip, "Transcription")
        zone3 =  QTextEdit(lab_transcrip)
        zone3.setGeometry(0,0,610,1500)
        zone3.scroll(0,1500)
        zone3.setReadOnly(True)
        zone3.setAlignment(Qt.AlignJustify)


        i=11
        while(i<18):
            zone3.append(texte[i])
            i=i+1
     


        lab_scores =  QLabel(self)
        tabW.addTab(lab_scores, "Scores")

        zone4 =  QTextEdit(lab_scores)
        zone4.setGeometry(0,0,610,1500)
        zone4.scroll(1500,0)
        zone4.setReadOnly(True)
        zone4.setAlignment(Qt.AlignJustify)


        i=18
        while(i<21):
            zone4.append(texte[i])
            i=i+1
     


        lab_sound =  QLabel(self)
        tabW.addTab(lab_sound, "Sound")

        zone5 =  QTextEdit(lab_sound)
        zone5.setGeometry(0,0,610,1500)
        zone5.scroll(1500,0)
        zone5.setReadOnly(True)
        zone5.setAlignment(Qt.AlignJustify)


        i=21
        while(i<24):
            zone5.append(texte[i])
            i=i+1


        lab_online =  QLabel(self)
        tabW.addTab(lab_online, "Online Help")

        zone6 =  QTextEdit(lab_online)
        zone6.setGeometry(0,0,610,1500)
        zone6.scroll(1500,0)
        zone6.setReadOnly(True)
        zone6.setAlignment(Qt.AlignJustify)


        i=24
        while(i<28):
            zone6.append(texte[i])
            i=i+1
     


        help_fermer =  QPushButton(self)
        help_fermer.setGeometry(300,675,60,20)
        help_fermer.setText("Close")

        help_fermer.clicked.connect(self.close)


    def chImage(self):
        self.lab = self.sender()
        if(self.lab in self.mLab):
            self.lab_sax.setPixmap(self.tabPix[self.lab.indent()])
            


    def initIm(self):
        self.lab_sax.setPixmap(self.saxo)

##############################################################################
#Fenetre About
class About(QDialog):
    def __init__(self,parent=None):
        super(About, self).__init__(parent)
        self.setFixedSize(350,200)
        self.setWindowTitle("About")

        self.labAbout = QLabel(self)
        self.labAbout.setFixedSize(350,150)
        self.titre1 = QFont("Palatino",14,1)
        self.titre1.setBold(True)
        self.titre1.setItalic(True)
        self.labAbout.setFont(self.titre1)
        self.labAbout.setAlignment(Qt.AlignHCenter)

        self.labAbout2 = QLabel(self)
        self.labAbout2.setGeometry(0,150,350,50)
        self.labAbout2.setAlignment(Qt.AlignHCenter) 

        self.labAbout.setText("G!ant Steps is developped in PyQt\n By \n Bernard Beltran.\n \n Contact me \n at \n")
        self.labAbout2.setFont(self.titre1)
        btMail = QPushButton(self.labAbout2)
        btMail.setGeometry(0,0,350,50)
        btMail.setFlat(True)
        imCurseur = QPixmap("images/hand1.png")
        curseurMail = QCursor(imCurseur)
        self.titre2 = QFont("Palatino",14,1)
        self.titre2.setBold(True)
        self.titre2.setUnderline(True)
        btMail.setFont(self.titre2)
        btMail.setCursor(curseurMail)
        btMail.setText("takefive@lescigales.org")

        btMail.clicked.connect(self.openMail)

    def openMail(self):              
        QDesktopServices.openUrl(QUrl("mailto:takefive@lescigales.org", QUrl.TolerantMode))
        

#############################################################################

class Tr(QDialog):
    def __init__(self,parent=None):
        super(Tr, self).__init__(parent)
        self.setFixedSize(640,640)
        self.setWindowTitle("Transcription")
        self.setWindowIcon(QIcon("images/trSax_3.png"))
        
        self.imgTr_1 = QPixmap("images/trSax_31.png")
        self.imgTr_2 = QPixmap("images/trSax_4.png")

        self.labTr_1 = QLabel(self)
        self.labTr_2 = QLabel(self)
        self.labTr_1.setPixmap(self.imgTr_1)
        self.labTr_2.setPixmap(self.imgTr_2)
        
        self.combo = QComboBox(self)
        
        self.combo.setStyleSheet("background-color: #ff8a23;border-width: 2px; border-color: black; border-style: solid; border-radius: 7;")
        
        self.pal = self.combo.palette()
        self.pal.setColor(QPalette.Highlight, QColor.fromRgb(248,122,19))
        self.combo.setPalette(self.pal)

        self.combo.setGeometry(10,10,150,30)
        comboFont = QFont("Palatino",11,1)
        comboFont.setItalic(True)
        comboFont.setBold(True)
        
        self.combo.setFont(comboFont)
        self.combo.setAutoFillBackground(True)
        self.combo.addItem("Choose a key", QColor.fromRgb(248,122,19))
        self.combo.insertSeparator(1)
        
        self.combo.addItem("C Instrument",QColor.fromRgb(248,122,19))
        self.combo.insertSeparator(3)
        self.combo.addItem("")
        
        self.combo.addItem("A",QColor.fromRgb(248,122,19))
        self.combo.addItem("B",QColor.fromRgb(248,122,19))
        self.combo.addItem("C#/D"+ (u"\u266d"),QColor.fromRgb(248,122,19))
        self.combo.addItem("D",QColor.fromRgb(248,122,19))
        self.combo.addItem("D#/E"+ (u"\u266d"),QColor.fromRgb(248,122,19))
        self.combo.addItem("E",QColor.fromRgb(248,122,19))
        self.combo.addItem("F",QColor.fromRgb(248,122,19))
        self.combo.addItem("F#/G"+ (u"\u266d"),QColor.fromRgb(248,122,19))
        self.combo.addItem("G",QColor.fromRgb(248,122,19))
        self.combo.addItem("G#/A"+ (u"\u266d"),QColor.fromRgb(248,122,19))
        
        self.combo.setItemData(0,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(1,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(2,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(3,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(4,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(5,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(6,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(7,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(8,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(9,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(10,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(11,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(12,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(13,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        self.combo.setItemData(14,QColor.fromRgb(248,122,19),Qt.BackgroundRole)
        
        texteSax = QLabel(self)
        texteSax.setGeometry(10,45,150,30)
        texteSax.setFont(comboFont)

        texteSax.setStyleSheet("background-color: #f8af51;border-width: 2px; border-color: black; border-style: solid; border-radius: 7;")
        texteSax.setAutoFillBackground(True)

        texteSax.setText("Tenor Saxophone B" + (u"\u266d"))


        fermeTr = QPushButton(self)
        fermeTr.setGeometry(600,600,40,40)
        fermeTr.setIcon(QIcon("images/fermer.png"))
        
        #self.connect(combo,SIGNAL(activated(QString)),this,SLOT(tourne(QString)))
        self.combo.activated.connect(self.tourne)
        #self.connect(fermeTr,SIGNAL(clicked()),this,SLOT(close()))
        fermeTr.clicked.connect(self.close)
        
        
    def tourne(self):
        matrix = QMatrix()
        

        if (self.combo.currentIndex()==0):
            self.labTr_2.setPixmap(self.imgTr_2)
    


        elif (self.combo.currentIndex()==2):
            matrix.rotate(-60)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==5):
            matrix.rotate(30)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==6):
            matrix.rotate(-30)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==7):
            matrix.rotate(-90)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter);
            
        elif (self.combo.currentIndex()==8):
            matrix.rotate(-120)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter);  
            
        elif (self.combo.currentIndex()==9):
            matrix.rotate(-150)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter);
            
        elif (self.combo.currentIndex()==10):
            matrix.rotate(-180)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==11):
            matrix.rotate(-210)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==12):
            matrix.rotate(-240)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==13):
            matrix.rotate(-270)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter)
            
        elif (self.combo.currentIndex()==14):
            matrix.rotate(-300)
            self.nvlle =  self.imgTr_2.transformed(matrix,Qt.SmoothTransformation)

            self.labTr_2.setPixmap(self.nvlle)
            self.labTr_2.setAlignment(Qt.AlignCenter);
      
   
    

##############################################################################

#La fenetre principale
class MainWindow(QMainWindow):
    mainWClosed = pyqtSignal()
    
    def __init__(self, parent=None):
        super(MainWindow, self).__init__(parent)
        self.setFixedSize(310,600)
        self.setWindowTitle("G!ant Steps")
        
        self.setWindowIcon(QIcon("images/screen.png"))
        
        self.setStyleSheet("QMenuBar{font-size : 12px} QMenu{font-size : 12px}")

        """On centre la fenetre au milieu de l ecran"""
        size_ecran = QDesktopWidget().screenGeometry()        
        self.move((size_ecran.width()-310)/2, (size_ecran.height()-600)/2)

        """Affichage de l image d accueil"""
        # widget-label qui contiendra l'objet-image  
        self.image = QLabel(self)
        self.image.setGeometry(0,23,310,475)
        # affichage de l'objet image dans le label  
        self.image.setPixmap(QPixmap("images/gs2_2.jpg"))

        """Initialisation de la zone texte"""
        self.nomNote = QLabel(self);
        self.nomNote.setStyleSheet("QLabel{border-width: 2px; border-color: black; border-style: solid;}");

        self.nomNote.setGeometry(60,530,190,30);
        notePolice= QFont("Palatino",15,QFont.UltraExpanded,True);
        self.nomNote.setFont(notePolice);
        self.nomNote.setAlignment(Qt.AlignHCenter);

        """On charge les tableaux de donnees et d images"""

        self.tabImages = [ QPixmap("images/SibGrave.png") ,  QPixmap("images/SiGrave.png") ,  QPixmap("images/DoGrave.png") ,  QPixmap("images/DodGrave.png") ,  QPixmap("images/ReGrave.png")
        ,  QPixmap("images/RedGrave.png") ,  QPixmap("images/MiGrave.png") ,  QPixmap("images/FaGrave.png") ,  QPixmap("images/FadGrave.png")
        ,  QPixmap("images/SolGrave.png") ,  QPixmap("images/SoldGrave.png") ,  QPixmap("images/LaGrave.png") ,  QPixmap("images/LadGrave1.png") ,  QPixmap("images/SiMedium.png") ,  QPixmap("images/DoMedium1.png")
        ,  QPixmap("images/DodMedium.png") ,  QPixmap("images/ReMedium.png") ,  QPixmap("images/RedMedium.png") ,  QPixmap("images/MiMedium.png") ,  QPixmap("images/FaMedium.png")
        ,  QPixmap("images/FadMedium.png") ,  QPixmap("images/SolMedium.png"), QPixmap("images/SoldMedium.png") ,   QPixmap("images/LaMedium.png") ,  QPixmap("images/LadMedium1.png")
        ,  QPixmap("images/SiA.png") ,  QPixmap("images/DoA.png") ,  QPixmap("images/DodA.png") ,  QPixmap("images/ReA.png") ,  QPixmap("images/RedA.png")
        ,  QPixmap("images/MiA1.png") ,  QPixmap("images/FaA1.png") ,  QPixmap("images/FadHigh1.png") , QPixmap("images/SolA1.png") , QPixmap("images/SoldA1.png")
        ,  QPixmap("images/LaA1.png"),  QPixmap("images/LadA1.png") , QPixmap("images/SiAA1.png") , QPixmap("images/DoAA1.png") , QPixmap("images/DodAA1.png")
        , QPixmap("images/ReAA1.png"), QPixmap("images/RedAA1.png"), QPixmap("images/MiAA1.png"), QPixmap("images/FaAA1.png")]

        self.tabImages_1 = [  QPixmap("images/SiGrave.png") ,  QPixmap("images/DoGrave.png")  ,  QPixmap("images/ReGrave.png")
        ,  QPixmap("images/MiGrave.png") ,  QPixmap("images/FaGrave.png")
        ,  QPixmap("images/SolGrave.png")  ,  QPixmap("images/LaGrave.png")  ,  QPixmap("images/SiMedium.png") ,  QPixmap("images/DoMedium1.png")
        ,  QPixmap("images/ReMedium.png") ,  QPixmap("images/MiMedium.png") ,  QPixmap("images/FaMedium.png")
        ,  QPixmap("images/SolMedium.png") ,   QPixmap("images/LaMedium.png")
        ,  QPixmap("images/SiA.png") ,  QPixmap("images/DoA.png")  ,  QPixmap("images/ReA.png")
        ,  QPixmap("images/MiA1.png") ,  QPixmap("images/FaA1.png"),  QPixmap("images/SolA1.png"),  QPixmap("images/LaA1.png")
        ,  QPixmap("images/SiAA1.png"),  QPixmap("images/DoAA1.png"),  QPixmap("images/ReAA1.png"),  QPixmap("images/MiAA1.png")
        ,  QPixmap("images/FaAA1.png")]

        self.notes_piano_N = [  QPixmap("images/SibGrave.png")  ,  QPixmap("images/DoGrave.png")
        ,  QPixmap("images/RedGrave.png")  ,  QPixmap("images/FaGrave.png")
        ,  QPixmap("images/SolGrave.png")  ,  QPixmap("images/LadGrave1.png")  ,  QPixmap("images/DoMedium1.png")
        ,  QPixmap("images/RedMedium.png") ,  QPixmap("images/FaMedium.png")
        ,  QPixmap("images/SolMedium.png") ,  QPixmap("images/LadMedium1.png")
        ,  QPixmap("images/DoA.png")  ,  QPixmap("images/RedA.png")
        ,  QPixmap("images/FaA1.png") ,  QPixmap("images/SolA1.png") ,  QPixmap("images/LadA1.png")
        ,  QPixmap("images/DoAA1.png") ,  QPixmap("images/RedAA1.png") ,  QPixmap("images/FaAA1.png")]


        self.notes_piano_B = [  QPixmap("images/SiGrave.png") ,  QPixmap("images/DodGrave.png") ,  QPixmap("images/ReGrave.png")
        ,  QPixmap("images/MiGrave.png") ,  QPixmap("images/FadGrave.png")
        ,  QPixmap("images/SoldGrave.png")  ,  QPixmap("images/LaGrave.png") ,  QPixmap("images/SiMedium.png")
        ,  QPixmap("images/DodMedium.png") ,  QPixmap("images/ReMedium.png")  ,  QPixmap("images/MiMedium.png")
        ,  QPixmap("images/FadMedium.png") , QPixmap("images/SoldMedium.png") ,   QPixmap("images/LaMedium.png")
        ,  QPixmap("images/SiA.png") ,  QPixmap("images/DodA.png") ,  QPixmap("images/ReA.png")
        ,  QPixmap("images/MiA1.png")  ,  QPixmap("images/FadHigh1.png") ,  QPixmap("images/SoldA1.png")
        ,  QPixmap("images/LaA1.png") ,  QPixmap("images/SiAA1.png") ,  QPixmap("images/DodAA1.png")
        ,  QPixmap("images/ReAA1.png"),  QPixmap("images/MiAA1.png")]

        bemol = u'\u266d'
        #b = bemol.encode('utf-8')
        self.tabNotes = [ "A#/B" + u'\u266d' + "low" , "B low" , "C low" , "C # / D" + (u'\u266d') + "low", "D low", "D # /E" + (u'\u266d') + "low"
        , "E low", "F low" ,"F#/G" + u'\u266d' + " low" , "G low", "G # /A" + (u'\u266d') + "low", "A low", "A# low / B"+(u'\u266d')+"med.", "B medium", "C medium"
        , "C# / D"+(u'\u266d')+"med.", "D medium", "D# / E"+(u'\u266d')+"med.", "E medium", "F medium" , "F# / G"+(u'\u266d')+"med." , "G medium" , "G # / A"+(u'\u266d')+"med."
        , "A medium" , "A # med/B"+(u'\u266d')+"high" ,"B high" , "C high" ,"C # / D"+(u'\u266d')+"high" , "D high" ,"D # / E"+(u'\u266d')+"high" , "E high", "F high" ,"F # /G"+(u'\u266d')+"high"
        , "G high" ,"G#/A"+(u'\u266d')+"Altissimo" , "A Altissimo" , "A#/B"+(u'\u266d')+"Altissimo"
        , "B Altissimo" ,"C Altissimo" , "C#/D"+(u'\u266d')+"Altissimo" , "D Altissimo" , "D#/E"+(u'\u266d')+"Altissimo"
        , "E Altissimo" , "F Altissimo"]

        
        self.tabNotes_1 = [ "B low" , "C low" , "D low"
        , "E low", "F low"  , "G low", "A low", "B medium", "C medium"
        , "D medium", "E medium", "F medium"  , "G medium"
        , "A medium"  ,"B high" , "C high"  , "D high" , "E high", "F high"
        ,"G high" , "A Altissimo" , "B Altissimo" , "C Altissimo"
        , "D Altissimo" , "E Altissimo" , "F Altissimo"]

        self.tabNotesAlt = [  "F#/G" + (u'\u266d') + " low" ,"A# low / B"+(u'\u266d')+"med." , "C medium"
        , "C#/D"+(u'\u266d')+"med." , "F#/G"+(u'\u266d')+"med."
        ,"A # med/B"+(u'\u266d')+"high" , "C medium" , "C# / D"+(u'\u266d')+"med."
        ,"F# / G"+(u'\u266d')+"med."  , "A # med/B"+(u'\u266d')+"high" ,"C high" ,"E high"
        ,"F high" ,"F # /G"+(u'\u266d')+"high" , "G high"
        ,"G#/A"+(u'\u266d')+"Altissimo"
        , "A Altissimo" , "A#/B"+(u'\u266d')+"Altissimo"
        , "B Altissimo" ,"C Altissimo"
        , "C#/D"+(u'\u266d')+"Altissimo"
        , "D Altissimo"
        , "D#/E"+(u'\u266d')+"Altissimo"
        , "E Altissimo" , "F Altissimo"]

        self.nom_notes_piano_N  = ["A # / B"+(u'\u266d') + "low" ,"C low" ,"D # /E" + (u'\u266d') + "low", "F low","G# / A "+ u'\u266d' + "low"
        ,"A# low / B"+(u'\u266d')+"med.","C medium","D# / E"+(u'\u266d')+"med."
        ,"F medium","G# / A "+ u'\u266d' + "medium","A # med/B"+(u'\u266d')+"high","C high","D # / E"+(u'\u266d')+"high","F high"
        ,"G# / A "+ u'\u266d' + "high" , "A#/B"+(u'\u266d')+"Altissimo" ,"C Altissimo" , "D#/E"+(u'\u266d')+"Altissimo"
        , "F Altissimo"]

        self.nom_notes_piano_B = ["B low","C # / D" + (u'\u266d') + "low","D low","E low","F#/G" + (u'\u266d') + " low"
        ,"G low","A low","B medium"
        ,"C# / D"+(u'\u266d')+"med.","D medium","E medium","F# / G"+(u'\u266d')+"med."
        ,"G medium","A medium","B high"
        ,"C# / D"+(u'\u266d')+"high","D high","E high","F # /G"+(u'\u266d')+"high"
        ,"G Altissimo" , "A Altissimo","B Altissimo","C#/D"+(u'\u266d')+"Altissimo"
        ,"D Altissimo","E Altissimo"]
        

        """Creation des fenetres"""
        self.f_portee = Portee(self)
        self.f_portee.setGeometry(10,20,489,500)
        self.f_portee.setFixedSize(489,500)

        self.f_piano = Piano(self)
        self.f_piano.setGeometry(10,550,400,100)
        self.f_piano.setFixedSize(400,100)

        self.f_partition = Partition(self)
        

        self.f_help = Help(self)

        self.f_about = About(self)
        
        self.f_tr = Tr(self)

        """On connect la portee a la fenetre prinicipale"""
        self.f_portee.signalMapper_portee.mapped.connect(self.afficheSaxo2)

        """Connexion de la portee au piano"""
        self.f_portee.signalMapper_portee.mapped.connect(self.fromStaffToPiano)

        """Connexion du piano a la fenetre principale"""
        self.f_piano.signalMapper_piano.mapped.connect(self.noteFromPiano)

        """Connexion de la fenetre principale a la portee"""
        self.f_piano.signalMapper_piano.mapped.connect(self.fromPianoToStaff)

        """Connexion de fermeture de l application """
        
        app.connect(self, SIGNAL("mainWindowClosed"), app, SLOT("quit()"))
        app.lastWindowClosed.connect(app.quit)
        #self.close.connect(app.quit)
        #self.quit.triggered.connect(qApp.quit)

        app.connect(app,SIGNAL("lastWindowClosed()"),app,SLOT("quit()"))
        self.mainWClosed.connect(self.quitApp)


        

        """creation du menu"""
        
        '''On cree d abord les actions'''
        #self.setStyleSheet("QMenu{font-size : 11px;}")
        
        
        self.portee = QAction(self)
        self.portee.setIcon(QIcon("images/cle-de-sol.jpg"))
        self.portee.setIconVisibleInMenu(True)
        self.portee.setText("Staff")

        self.piano = QAction(self)
        self.piano.setIcon(QIcon("images/piano-icone.png"))
        self.piano.setIconVisibleInMenu(True)
        self.piano.setText("Piano")

        self.closeAct = QAction(self)

        self.closeAct.setIcon(QIcon("images/quitter.png"))
        self.closeAct.setIconVisibleInMenu(True)
        self.closeAct.setShortcut(QKeySequence("Ctrl+q"))
        self.closeAct.setText("Quit")

        self.partitions = QAction(self)
        self.partitions.setIcon(QIcon("images/open_part.png"))
        self.partitions.setIconVisibleInMenu(True)
        self.partitions.setShortcut(QKeySequence("Ctrl+u"))
        self.partitions.setText("Open a score (.pdf or picture)")



        i=0
        self.actionsPro = ['','','','','','','','','','']
        while(i< 10):
            self.actionsPro[i] = QAction(self)
            self.actionsPro[i].setVisible(False)
            #self.connect(self.actionsPro[i], SIGNAL("triggered()"),self, SLOT("ouvrirPro()"))
            i=i+1
    
        self.vide = QAction(self)
        self.vide.setText(" -> Empty list")
    
    
        self.tr = QAction(self)
        self.tr.setText("Transcription")
        self.tr.setIcon(QIcon("images/trSax_3.png"))
        
    
        self.aide = QAction(self)
        self.aide.setIcon(QIcon("images/aide.png"))
        self.aide.setIconVisibleInMenu(True)
        self.aide.setText("Help")
        self.aide.setShortcut(Qt.Key_F1)
        self.apropos = QAction(self)
        self.apropos.setIcon(QIcon("images/apropos.png"))
        self.apropos.setIconVisibleInMenu(True)
        self.apropos.setText("About")
        self.apropos.setShortcut(Qt.Key_F9)

        
        menu =  QMenu(self)
        
        menu = self.menuBar().addMenu("&Menu")
        menu.addAction(self.portee)
        menu.addAction(self.piano)



        
        menu.addSeparator()
        menu.addSeparator()
        
        menu.addAction(self.closeAct)

        menupart = QMenu(self)
        menupart = self.menuBar().addMenu("Scores")

        menupart.addAction(self.partitions)

        menuPro = menupart.addMenu("Recently opened scores")
        menuPro.setIcon(QIcon("images/pro.png"))
        i=0
        while(i < 10):
           menuPro.addAction(self.actionsPro[i])
           self.actionsPro[i].triggered.connect(self.ouvrirPro);
           i=i+1
        
        menuPro.addSeparator()
        menuPro.addAction(self.vide)

        menuGammes = self.menuBar().addMenu("Transcription")
        transcription = QMenu(self)
        transcription.setTitle("Transcription")
        
        
        
        
        menuGammes.addAction(self.tr)
       

        menuAide = self.menuBar().addMenu("&Help")
        menuAide.addAction(self.aide)
        menuAide.addAction(self.apropos)

        """Connexion des actions au menu"""
        #self.connect(self.portee, SIGNAL("triggered()"), Portee, SLOT("self.showPortee()"))
        self.portee.triggered.connect(self.showPortee)
        self.piano.triggered.connect(self.showPiano)
        self.closeAct.triggered.connect(self.closeAll)
        self.partitions.triggered.connect(self.showMenuPartitions)
        self.partitions.triggered.connect(self.miseAJourActionsPro)
        self.vide.triggered.connect(self.emptyList)
        self.aide.triggered.connect(self.showHelp)
        self.apropos.triggered.connect(self.showAbout)
        
        self.tr.triggered.connect(self.showTr)

        """Boutons diese et bemol, VolumeSlider"""

        self.signalMapper = QSignalMapper(self)

        #connect(signalMapper, SIGNAL(mapped(int)), this, SLOT(action(int)));
        self.signalMapper.mapped.connect(self.action)
        #connect(signalMapper,SIGNAL(mapped(int)),fen_portee,SLOT(moveNote(int)));
        self.signalMapper.mapped.connect(self.f_portee.moveNote)
        #connect(signalMapper,SIGNAL(mapped(int)),fen_piano,SLOT(moveNotePiano(int)));
        self.signalMapper.mapped.connect(self.moveNotePiano)

        noteDB = QFont("Palatino",17,QFont.Bold,True)
        i=0
        self.buttons = ['','']
        while (i < 2):
            self.buttons[i] = QPushButton(self)
            self.buttons[i].setFont(noteDB)
            self.buttons[i].setGeometry(260,535+30*i,50,30)
            self.buttons[i].setDisabled(True)
            self.signalMapper.setMapping(self.buttons[i], i)
            #connect(buttons[i], SIGNAL(clicked()), signalMapper, SLOT(map()))
            self.buttons[i].clicked.connect(self.signalMapper.map)
            i=i+1


        self.buttons[0].setText("#")
        res = bemol
        self.buttons[1].setText(res)


        #Bouton des doigtes alternatifs
        elemPolice = QFont("OldEnglish",10,QFont.Bold,True)
        self.dgtAlt = QPushButton(self)
        self.dgtAlt.setFont(elemPolice)
        self.dgtAlt.setGeometry(80,570,150,30)
        self.dgtAlt.setText("Alternative Position")
        self.dgtAlt.setEnabled(False)

        self.fermAlt =  QPushButton(self)
        self.fermAlt.setGeometry(225,570,30,30)
        self.fermAlt.setIcon(QIcon("images/fermer.png"))

        

        #self.dgtAlt.clicked.connect(self.alt_test.altshow)
        #self.fermAlt.clicked.connect(Alt.altclose)


        #playAction = QAction(standardIcon(QStyle.SP_MediaPlay), "Play", self);
        self.playAction = QAction("Play", self)
        self.playAction.setShortcut(("Crl+P"))
        self.playAction.setVisible(True)
        self.playAction.triggered.connect(self.play_note)
        

        bar = QToolBar(self)

        bar.addAction(self.playAction)
        bar.setMovable(False)

        bar.setVisible(True)
        bar.setGeometry(0,525,40,40)
        bar.setEnabled(True)

        self.volumeSlider = QSlider(Qt.Horizontal)

        self.volumeSlider.setGeometry(0,570,80,30)

        self.volumeSlider.setEnabled(True)
        #self.volumeSlider.setAudioOutput(audioOutput)

        self.volumeSlider.setSizePolicy(QSizePolicy.Maximum, QSizePolicy.Maximum)

        self.miseAJourActionsPro()
        

    def showPiano(self):
        if self.f_piano.isVisible(): self.f_piano.hide()
        else: self.f_piano.show()
 
    def showPortee(self):        
        if self.f_portee.isVisible(): self.f_portee.hide()
        else: self.f_portee.show()

    def showHelp(self):
        if self.f_help.isVisible(): self.f_help.hide()
        else: self.f_help.show()

    def showAbout(self):
        if self.f_about.isVisible(): self.f_about.hide()
        else: self.f_about.show()
        
    def showTr(self):
        if self.f_tr.isVisible(): self.f_tr.hide()
        else: self.f_tr.show()

    def ouvrirPro(self,action):
        self.action = self.sender()
        if(self.action):
            
            filtrePdf = "pdf"
        
        #self.setSizePolicy(QSizePolicy.Maximum,QSizePolicy.Maximum)
        
            info = QFileInfo(((self.action.text())))
            base = info.suffix()
            path = info.filePath()

            if(base == filtrePdf):
                QDesktopServices.openUrl(QUrl(info.filePath()))
        

            else:
                image_part = QImage(info.filePath())
                #image_part.load(str(self.action))
                label_part = QLabel(self.f_partition)
                pixmap_part = QPixmap.fromImage(image_part)
                label_part.setPixmap(pixmap_part)
                label_part.show()
                self.f_partition.show()

        self.setCurrentFile(self.action.text())

    def showMenuPartitions(self):
        choix = QFileDialog.getOpenFileName(self,'',"./")
        

        if(choix):
               self.setCurrentFile(choix)
               self.ouvrir(choix)
               self.miseAJourActionsPro()
               #menu.clearFocus()    

    def ouvrir(self,chaine):
        filtrePdf = "pdf"
        
        #self.setSizePolicy(QSizePolicy.Maximum,QSizePolicy.Maximum)
        
        info = QFileInfo(chaine)
        base = info.suffix()
        path = info.filePath()
        

        if(base == filtrePdf):
            QDesktopServices.openUrl(QUrl(path))
        

        else:
            image_part = QImage(path)
            image_part.load(path)
            label_part = QLabel(self.f_partition)
            
            pixmap_part = QPixmap.fromImage(image_part)
            
            label_part.setPixmap(pixmap_part)
            
            label_part.show()
            
            self.f_partition.show()


    def closeAll(self):
        self.close()
        self.f_portee.close()
        self.f_piano.close()
        self.f_partition.close()
        qApp.quit()

    def quitApp(self):
        self.f_portee.close()
        self.f_piano.close()
        self.f_partition.close()
        qApp.quit()

    def closeEvent(self, event):
        self.emit(SIGNAL("mainWClosed()"))
        

    def afficheSaxo2(self, indexNote):
        self.buttons[0].setEnabled(True)
        self.buttons[1].setEnabled(True)
    #    MainWindow.image.setUpdatesEnabled(True)
        self.doigt = self.tabImages_1[26-indexNote]
        self.image.setPixmap(self.doigt)
        self.image.update()
        self.image.show()
        self.nomNote.setText(self.tabNotes_1[26-indexNote])
        self.afficheSaxoAltNote2()
        self.play_note(self.tabNotes.index(self.nomNote.text()))

    def play_note(self,indexNote):
        print(indexNote)
        if (indexNote == False):
            self.testSon = Son(self.tabNotes.index(unicode(self.nomNote.text())))
            self.testSon.start()
        else:
            self.testSon = Son(indexNote)
            self.testSon.start()
        
        
        
 #       i=0
 #       while(i<25):
 #           if (self.nomNote.text() == self.tabNotesAlt.at(i)):
 #               self.dgtAlt.setDisabled(False)
 #               break
 #           else:
 #               self.dgtAlt.setDisabled(True)
 #           i=i+1
        
    ###Connexion des boutons dieses et bemol a la portee et a la fenetre principale###
    def action(self, monIndice):
        if (monIndice == 0):
            i=0
            while(i<43):
                if (self.nomNote.text() == self.tabNotes[i] ):
                    if (i==0):
                        nouveau = self.tabImages[1]
                        self.image.setPixmap(nouveau)
                        self.nomNote.setText(self.tabNotes[1])
                        self.image.show()
                        Portee().moveNote(0)
                        break
                        

                    else:
                        nouveau = self.tabImages[i+1]
                        self.image.setPixmap(nouveau)
                        self.nomNote.setText(self.tabNotes[i+1])
                        self.image.show()
                        Portee().moveNote(0)
                        break
                    
                i=i+1

        elif (monIndice == 1):
            i=0
            while(i<44):
                if (self.nomNote.text() == self.tabNotes[i] and i!=0):
                    nouveau = self.tabImages[i-1]
                    self.image.setPixmap(nouveau)
                    self.nomNote.setText(self.tabNotes[i-1])
                    self.image.show()
                    Portee().moveNote(1)
                    break
                i=i+1
        k=0
     
        if (self.nomNote.text() in self.tabNotesAlt):
            self.dgtAlt.setEnabled(True)
            
        elif (not(self.nomNote.text() in self.tabNotesAlt)):
            self.dgtAlt.setEnabled(False)

            
        self.play_note(self.tabNotes.index(unicode(self.nomNote.text())))
        self.afficheSaxoAltNote2()

###Connexion des boutons dieses et bemol au piano###

    def moveNotePiano(self, a):

        if(a==0):
            i=20
            while(i<46):
                if ((self.f_piano.boutonB[i].iconSize() != QSize(0,0))):
                    self.f_piano.boutonB[i].setIcon(QIcon(""))
                    self.f_piano.boutonB[i].setIconSize(QSize(0,0))
                    j=0
                    while(j<4):
                        if( i==1+7*j+20 or i==4+7*j+20 ):
                            self.f_piano.boutonB[i+1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+1].setIconSize(QSize(20,20))
                            return

                        elif (i==7*j+20):
                            self.f_piano.boutonN[i-2*j-20+1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20+1].setIconSize(QSize(20,20))
                            return

                        elif ( i==2+7*j+20 ):
                            self.f_piano.boutonN[i-2*j-20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20].setIconSize(QSize(20,20))
                            return

                        elif(i==3+7*j+20):
                            self.f_piano.boutonN[i-2*j-20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20].setIconSize(QSize(20,20))
                            return

                        elif( i==5+7*j+20):
                            self.f_piano.boutonN[i-2*j-20-1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20-1].setIconSize(QSize(20,20))
                            return
                        
                        elif( i== 6+7*j+20 ):
                            self.f_piano.boutonN[i-2*j-20-1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20-1].setIconSize(QSize(20,20))
                            return

                        
                        j=j+1
                i=i+1
                        
            i=0
            while(i<18):
                if((self.f_piano.boutonN[i].iconSize() != QSize(0,0)) and i<19):
                    self.f_piano.boutonN[i].setIcon(QIcon(""))
                    self.f_piano.boutonN[i].setIconSize(QSize(0,0))
                    j=0
                    while (j<4):
                        if(i==5*j or i==1+5*j):
                            self.f_piano.boutonB[i+2*j+20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+20].setIconSize(QSize(20,20))

                        elif (i==2+5*j or i==3+5*j):
                            self.f_piano.boutonB[i+2*j+1+20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+1+20].setIconSize(QSize(20,20))

                        elif (i==4+5*j):
                            self.f_piano.boutonB[i+2*j+20+2].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+20+2].setIconSize(QSize(20,20))
                        j=j+1
                i=i+1

        elif (a==1):
            i=20
            while(i<46):
                if ((self.f_piano.boutonB[i].iconSize() != QSize(0,0))):
                    self.f_piano.boutonB[i].setIcon(QIcon(""))
                    self.f_piano.boutonB[i].setIconSize(QSize(0,0))
                    j=0
                    while(j<4):
                        if((i==5+7*j+20) or i==2+7*j+20):
                            self.f_piano.boutonB[i-1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i-1].setIconSize(QSize(20,20))
                            return

                        elif((i==7*j+20)):
                            self.f_piano.boutonN[i-2*j-20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20].setIconSize(QSize(20,20))
                            return

                        elif (i==1+7*j+20):
                            self.f_piano.boutonN[i-2*j-20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20].setIconSize(QSize(20,20))
                            return
                            
                        elif( i==4+7*j+20 ):
                            self.f_piano.boutonN[i-2*j-1-20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-1-20].setIconSize(QSize(20,20))
                            return
                        
                        elif (i==3+7*j+20):
                            self.f_piano.boutonN[i-2*j-20-1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20-1].setIconSize(QSize(20,20))
                            return
                        
                        elif (i==6+7*j+20):
                            self.f_piano.boutonN[i-2*j-20-2].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonN[i-2*j-20-2].setIconSize(QSize(20,20))
                            return
                        
                        j=j+1
                i=i+1

            i=0
            while(i<19):
                if((self.f_piano.boutonN[i].iconSize() != QSize(0,0)) and i!=0):
                    self.f_piano.boutonN[i].setIcon(QIcon(""))
                    self.f_piano.boutonN[i].setIconSize(QSize(0,0))
                    j=0
                    while (j<4):
                        if(i==5*j ):
                            self.f_piano.boutonB[i+2*j+20-1].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+20-1].setIconSize(QSize(20,20))

                        elif ( i==1+5*j):
                            self.f_piano.boutonB[i+2*j-1+20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j-1+20].setIconSize(QSize(20,20))

                        elif (i==2+5*j or i==3+5*j):
                            self.f_piano.boutonB[i+2*j+20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+20].setIconSize(QSize(20,20))

                        elif ( i==4+5*j):
                            self.f_piano.boutonB[i+2*j+1+20].setIcon(QIcon("images/btnpiano.png"))
                            self.f_piano.boutonB[i+2*j+1+20].setIconSize(QSize(20,20))
                        j=j+1
                i=i+1


###Connexion du piano a la (vers) fenetre principale###

    def noteFromPiano(self, ind):

        self.f_piano.initIconPiano()
        rg1 = [0,7,14,21]
        
        if(ind>=20 and ind<46):
            self.nvImg = self.notes_piano_B[ind-19]
            self.image.setPixmap(self.nvImg)
            #self.f_piano.boutonB[ind].setFlat(False)
            self.f_piano.boutonB[ind].setIcon(QIcon("images/btnpiano.png"))
            self.f_piano.boutonB[ind].setIconSize(QSize(20,20))
            self.nomNote.setText(self.nom_notes_piano_B[ind-20])
            k=0
            while ( k<25 ):
                if (self.tabNotesAlt[k]== self.nomNote.text()):
                    self.dgtAlt.setDisabled(False)
                 
                else:
                    self.dgtAlt.setDisabled(True)
                k=k+1
            ind2 = ind-20
            if(ind2 in rg1):
                self.play_note((ind2/7) * 12 +1)
            elif(ind2 in [1,8,15,22]):
                self.play_note(((ind2-1)/7)*12 + 3)
            elif (ind2 in[2,9,16,23]):
                self.play_note(((ind2-2)/7)*12 + 4)
            elif (ind2 in[3,10,17,24]):
                self.play_note(((ind2-3)/7)*12 + 6)
            elif(ind2 in [4,11,18,25]):
                self.play_note(((ind2-4)/7)*12 + 8)
            elif(ind2 in [5,12,19]):
                self.play_note(((ind2-5)/7)*12 + 9)
            elif(ind2 in[6,13,20]):
                self.play_note(((ind2-6)/7)*12 +11)

        elif (ind<20):
            self.nvImg = self.notes_piano_N[ind]
            self.image.setPixmap(self.nvImg)
            #self.f_piano.boutonN[ind].setFlat(False)
            self.f_piano.boutonN[ind].setIcon(QIcon("images/btnpiano.png"))
            self.f_piano.boutonN[ind].setIconSize(QSize(20,20))
            self.nomNote.setText(self.nom_notes_piano_N[ind])
            k=0
            while ( k<25 ):
                if (self.tabNotesAlt[k]== self.nomNote.text()):
                    self.dgtAlt.setDisabled(False)
                    
                else:
                    self.dgtAlt.setDisabled(True)
                k=k+1
                
            if (ind in [0,5,10,15]):
                self.play_note((ind/5) * 12)
            elif(ind in [1,6,11,16]):
                self.play_note(((ind-1)/5)*12 + 2)
            elif(ind in [2,7,12,17]):
                self.play_note(((ind-2)/5)*12 + 5)
            elif(ind in [3,8,13,18]):
                self.play_note(((ind-3)/5)*12 + 7)
            elif(ind in [4,9,14,19]):
                self.play_note(((ind-4)/5)*12 + 10)

        self.fromMainToStaff(ind)
        self.afficheSaxoAltNote2()


    def fromStaffToPiano(self,k):
        self.f_piano.initIconPiano()
        n = 26-k
        if(n==0 or n==7 or n==14 or n==21):
            self.f_piano.boutonB[n+20].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonB[n+20].setIconSize(QSize(20,20));

        
        elif (n==2 or n==9 or n==16 or n==23):
            self.f_piano.boutonB[n+20].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonB[n+20].setIconSize(QSize(20,20));
        
        elif (n==3 or n==10 or n==17 or n==24):
            self.f_piano.boutonB[n+20].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonB[n+20].setIconSize(QSize(20,20));
        
        elif (n==6 or n==13 or n==20):
            self.f_piano.boutonB[n+20].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonB[n+20].setIconSize(QSize(20,20));
            
        
        elif (n==1):
            self.f_piano.boutonN[n].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n].setIconSize(QSize(20,20));
        
        elif (n==8):
            self.f_piano.boutonN[n-2].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-2].setIconSize(QSize(20,20));
        
        elif (n==15):
            self.f_piano.boutonN[n-4].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-4].setIconSize(QSize(20,20));
        
        elif (n==4):
            self.f_piano.boutonN[n-1].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-1].setIconSize(QSize(20,20));
        
        elif (n==11):
            self.f_piano.boutonN[n-3].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-3].setIconSize(QSize(20,20));
        
        elif (n==18):
            self.f_piano.boutonN[n-5].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-5].setIconSize(QSize(20,20));
        
        elif (n==5 or n==12 or n==19):
            self.f_piano.boutonB[n+20].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonB[n+20].setIconSize(QSize(20,20));
        
        elif (n==22):
            self.f_piano.boutonN[n-6].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-6].setIconSize(QSize(20,20));
        

        elif (n==25):
            self.f_piano.boutonN[n-7].setIcon(QIcon("images/btnpiano.png"));
            self.f_piano.boutonN[n-7].setIconSize(QSize(20,20));
        
    def fromMainToStaff(self, p):
        self.buttons[0].setEnabled(True)
        self.buttons[1].setEnabled(True)


        if (p>=0 and p<20):
            doigtB = self.notes_piano_N[p]
            self.image.setPixmap(doigtB)
            self.image.update()
            self.image.show()
            self.nomNote.setText(self.nom_notes_piano_N[p]) 
        elif (p>=20 and p<46):            
            doigtB = self.notes_piano_B[p-20]
            self.image.setPixmap(doigtB)
            self.image.update()
            self.image.show()
            self.nomNote.setText(self.nom_notes_piano_B[p-20])
            
        k=0
        while (k<25):            
            if (self.nomNote.text()== self.tabNotesAlt[k]):                
                self.dgtAlt.setDisabled(False)
                break
            else:
                self.dgtAlt.setDisabled(True)
            k=k+1

    def fromPianoToStaff(self, indc):
        self.f_portee.initPortee()
        
        grave = [1,2,3,4]
        medium = [5,6,7,8,9,10]
        high = [11,12,13,14]
        alto = [15,16,17,18]

        hauteur = [grave, medium, high, alto]
        
        do = [1,6,11,16]
        fa = [3,8,13,18]
        rediese = [2,7,12,17]
        soldiese = [4,9,14]
        ladiese = [5,10,15]

        si = [20,27,34,41,  22,29,36,43,  23,30,37,44,   25,32,39,   26,33,40]
        dodiese = [21,28,35,42   ,24,31,38]
        
        if(indc==0):
            self.f_portee.boutonZone[26-indc].setIcon(QIcon("images/noteBemol11.png"))
            self.f_portee.boutonZone[26-indc].setIconSize(QSize(60,30))

        elif(indc in do):
            self.f_portee.boutonZone[26-indc-2*do.index(indc)].setIcon(QIcon("images/note11.png"))
            self.f_portee.boutonZone[26-indc-2*do.index(indc)].setIconSize(QSize(30,30))

        elif (indc in fa):
            self.f_portee.boutonZone[25-indc-2*fa.index(indc)].setIcon(QIcon("images/note11.png"))
            self.f_portee.boutonZone[25-indc-2*fa.index(indc)].setIconSize(QSize(30,30))

        elif (indc in rediese):
            self.f_portee.boutonZone[26-indc-2*rediese.index(indc)].setIcon(QIcon("images/noteDiese11.png"))
            self.f_portee.boutonZone[26-indc-2*rediese.index(indc)].setIconSize(QSize(60,30))

        elif (indc in soldiese):
            self.f_portee.boutonZone[25-indc-2*soldiese.index(indc)].setIcon(QIcon("images/noteDiese11.png"))
            self.f_portee.boutonZone[25-indc-2*soldiese.index(indc)].setIconSize(QSize(60,30))

        elif (indc in ladiese):
            self.f_portee.boutonZone[25-indc-2*ladiese.index(indc)].setIcon(QIcon("images/noteDiese11.png"))
            self.f_portee.boutonZone[25-indc-2*ladiese.index(indc)].setIconSize(QSize(60,30))

        elif (indc in si):
            self.f_portee.boutonZone[46-indc].setIcon(QIcon("images/note11.png"))
            self.f_portee.boutonZone[46-indc].setIconSize(QSize(30,30))

        elif (indc in dodiese):
            self.f_portee.boutonZone[46-indc].setIcon(QIcon("images/noteDiese11.png"))
            self.f_portee.boutonZone[46-indc].setIconSize(QSize(60,30))


            
    def afficheSaxoAltNote2(self):

        i =0
        
        self.alt_test = ['','','','']
        self.alt_test[0]=Alt(QPixmap(""))
        self.alt_test[1]=Alt(QPixmap(""))
        self.alt_test[2]=Alt(QPixmap(""))
        self.alt_test[3]=Alt(QPixmap(""))
        
        
        if (self.nomNote.text() == "F Altissimo"):
            self.dgtAlt.setEnabled(True)
            self.alt_test[0] =  Alt(QPixmap("images/FaAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/FaAA3.png"))

            i=1


        elif (self.nomNote.text() == "E Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/MiAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/MiAA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/MiAA4.png"))
            i=2
    

        elif (self.nomNote.text() == "D#/E"+"\u266d"+"Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/RedAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/RedAA3.png"))
            i=1
    

        elif (self.nomNote.text() == "D Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/ReAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/ReAA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/ReAA4.png"))
            i=2

    

        elif (self.nomNote.text() == "C#/D"+u'\u266d'+"Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/DodAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/DodAA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/DodAA4.png"))
            i=2


        elif (self.nomNote.text() == "C Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/DoAA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/DoAA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/DoAA4.png"))
            self.alt_test[3] =  Alt(QPixmap("images/DoAA5.png"))
            i=3

    

        elif (self.nomNote.text() == "B Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/SiA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/SiA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/SiA4.png"))
            self.alt_test[3] =  Alt(QPixmap("images/SiA5.png"))
            i=3
    

        elif (self.nomNote.text() == "A#/B"+u'\u266d'+"Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/LadA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/LadA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/LadA4.png"))
            self.alt_test[3] =  Alt(QPixmap("images/LadA5.png"))
            i=3

    

        elif (self.nomNote.text() == "A Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/LaA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/LaA3.png"))
            i=1
    

        elif (self.nomNote.text() == "G#/A"+u'\u266d'+"Altissimo"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/SoldA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/SoldA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/SoldA4.png"))
            self.alt_test[3] =  Alt(QPixmap("images/SoldA5.png"))
            i=3

    

        elif (self.nomNote.text() == "G high"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/SolA2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/SolA3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/SolA4.png"))
            self.alt_test[3] =  Alt(QPixmap("images/SolA5.png"))
            i=3

    

        elif (self.nomNote.text() == "F # /G"+(u'\u266d')+"high"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/FadHigh2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/FadHigh3.png"))
            self.alt_test[2] =  Alt(QPixmap("images/FadHigh4.png"))
            i=2
    

        elif (self.nomNote.text() == "F high"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/FaA2.png"))
            i=0
    

        elif (self.nomNote.text() == "E high"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/MiA2.png"))
            i=0
    

        elif (self.nomNote.text() == "C high"):
            self.dgtAlt.setEnabled(True)
            self.alt_test[0] =  Alt(QPixmap("images/DoA2.png"))
            i=0
    

        elif (self.nomNote.text() == "A # med/B"+u'\u266d'+"high"):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/LadMedium2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/LadMedium3.png"))
            i=1
    

        elif (self.nomNote.text() == "F# / G"+u'\u266d'+"med."):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/FadMedium2.png"))
            i=0

    

        elif (self.nomNote.text() == "C# / D"+(u'\u266d')+"med."):
            self.dgtAlt.setEnabled(True)
    

            self.alt_test[0] =  Alt(QPixmap("images/DodMedium2.png"))
            i=0
    

        elif (self.nomNote.text() == "C#/D"+u'\u266d'+"med."):
            self.dgtAlt.setEnabled(True)
    

            self.alt_test[0] =  Alt(QPixmap("images/DodMedium1.png"))
            i=0
    

        elif (self.nomNote.text() == "A# low / B"+u'\u266d'+"med."):
            self.dgtAlt.setEnabled(True)
    
            self.alt_test[0] =  Alt(QPixmap("images/LadGrave2.png"))
            self.alt_test[1] =  Alt(QPixmap("images/LadGrave3.png"))
            i=1
    

        elif (self.nomNote.text() == ("F#/G" + u'\u266d' + " low")):
            self.dgtAlt.setEnabled(True)
            self.alt_test[0] =  Alt(QPixmap("images/FadGrave1.png"))
            i=0
            
        else:
            self.dgtAlt.setEnabled(False)
            i=-1
    
        j=0
        while(j<i+1):
            #connect(fermAlt,SIGNAL(clicked()),self.alt_test[j],SLOT(close()))
            self.fermAlt.clicked.connect(self.alt_test[j].altclose)
            self.alt_test[j].setWindowTitle(self.nomNote.text())
            self.alt_test[j].setGeometry(200+50*j,200+50*j,310,490)
            self.dgtAlt.clicked.connect(self.alt_test[j].altshow)
            #self.alt_test[j].show()
            j=j+1


    def setCurrentFile(self,fileName):

        curFile = fileName
        fichier = QFile()
        fichier.setFileName("./fichier.txt")

        inn = QTextStream(fichier)
        fichier = open("./fichier.txt", "a")
    
        fichier.write(fileName + "\n")
        fichier.close()

        self.miseAJourActionsPro()




#Mise a jour du menu des partitions recemment ouvertes
    def miseAJourActionsPro(self):
        fichier = QFile()
        fichier.setFileName("./fichier.txt")

        out = QTextStream(fichier)
        liste = ['']

        fichier.open(QFile.ReadWrite)
        k=0
        while (not out.atEnd()):
            line = out.readLine()
            liste.append(line)
            k=k+1

        if(k>10):
            fichier.resize(10)
            i=10
            while(i<k):
                liste.remove(line[i])
                i=i+1
            j=0
            while(j<10):
                out.append(line[j])
                j=j+1

        elif k==0 :
            fichier.resize(0)
            
            
        i=0
        if k!=0 :
            for i in list(range(k)):
                self.actionsPro[i].setText(liste[k-i])
                self.actionsPro[i].setVisible(True)
                i=i+1
     
        elif k==0 :
            for i in list(range(10)):
                self.actionsPro[i].setVisible(False)
  


        fichier.close()
        
    def emptyList(self):
        fichier = QFile()
        fichier.setFileName("./fichier.txt")

        fichier.open(QFile.ReadWrite)
        fichier.resize(0)
        
        
        fichier.close()
        self.miseAJourActionsPro()

if __name__ == '__main__':
   
    app = QApplication(sys.argv)
    
    splash_pix = QPixmap('images/screen.png')
    splash = QSplashScreen(splash_pix, Qt.WindowStaysOnTopHint)
    splash.setMask(splash_pix.mask())
    splash.show()
    Son(50).start()
    app.processEvents()
    
    frame = MainWindow()
    
    splash.finish(frame)
    
    frame.show()
    app.exec_()